// -*- mode: js; js-indent-level: 4; indent-tabs-mode: nil -*-

const AltTab = imports.ui.altTab;

let _originalInit;

const _init = function(apps, altTabPopup)
{
    _originalInit.apply(this, [apps, altTabPopup]);

    let workspace = global.screen.get_active_workspace();
    let addedApps = this.icons;
    let addedArrows = this._arrows;
    let currentApp = 1, nApp, currentWindow, nWindow;
    let oldArrow, oldWindows, oldApp, oldText;
    let found, i;

    for (nApp = currentApp; nApp < addedApps.length; nApp++)
    {
        found = 0;
        currentWindow = 0;

        for (nWindow = 0; nWindow < addedApps[nApp].cachedWindows.length; nWindow++)
            if (addedApps[nApp].cachedWindows[nWindow].get_workspace() == workspace)
            {
                found++;

                if (nWindow > currentWindow)
                {
                    oldWindows = addedApps[nApp].cachedWindows[nWindow];

                    for (i = nWindow; i > currentWindow; i--)
                        addedApps[nApp].cachedWindows[i] = addedApps[nApp].cachedWindows[i - 1];

                    addedApps[nApp].cachedWindows[currentWindow] = oldWindows;

                    currentWindow++;
                }
            }

        if (!found)
            continue;

        if (nApp == currentApp)
        {
            currentApp++;
            continue;
        }

        oldArrow = addedArrows[nApp];
        oldWindows = addedApps[nApp].cachedWindows;
        oldApp = addedApps[nApp].app;
        oldText = addedApps[nApp].label.text;

        for (i = nApp; i > currentApp; i--)
        {
                addedArrows[i] = addedArrows[i - 1];
                addedApps[i].cachedWindows = addedApps[i - 1].cachedWindows;
                addedApps[i].app = addedApps[i - 1].app;
                addedApps[i].label.text = addedApps[i - 1].label.text;
        }

        addedArrows[currentApp] = oldArrow;
        addedApps[currentApp].cachedWindows = oldWindows;
        addedApps[currentApp].app = oldApp;
        addedApps[currentApp].label.text = oldText;

        currentApp++;
    }
};

function enable()
{
    _originalInit = AltTab.AppSwitcher.prototype._init;
    AltTab.AppSwitcher.prototype._init = _init;
}

function disable()
{
    AltTab.AppSwitcher.prototype._init = _originalInit;
}
